#ifndef MOVE_HPP
#define MOVE_HPP

#include "pieces/piece.hpp"
class Piece;

/// Représente un coup dans le jeu
class Move{


	private:
		/// Pièce étant à l'origine du coup
		const Piece moved_piece;
		/// Case d'origine
		Square old_pos;
		/// Case de destination
		Square new_pos;

	public:
		/// Constructeur de la classe Move
		/// @param moved_piece Pièce étant à l'origine du coup
		/// @param old_pos Case d'origine
		/// @param new_pos Case de destination
		Move(const Piece& moved_piece, Square old_pos, Square new_pos) : moved_piece(moved_piece), old_pos(old_pos), new_pos(new_pos) {};

		/// Récupère la pièce à l'origine du coup
		/// @return Pointeur de la pièce à l'origine du coup
		const Piece * get_moved_piece() const {
			return &moved_piece;
		}

		/// Case d'origine
		Square get_old_pos() const {
			return old_pos;
		}

		/// Case de destination
		Square get_new_pos() const {
			return new_pos;
		}
};

#endif