#ifndef SQUARE_HPP
#define SQUARE_HPP

#include <string>

/// @brief Décrit une case de l'échiquier
class Square{
	private:
		/// @brief Coordonnées de la case
		int row, col;
	public:
		/// Récupère la ligne et la colonne décrite par l'objet
		/// @param row [out] Ligne de la case
		/// @param col [out] Colonne de la case
		void get_row_col(int& row, int& col) const{
			row = this->row;
			col = this->col;
		};

		/// Récupère la ligne où se trouve la pièce
		/// @return Ligne
		int get_row() const { return row; }

		/// Récupère la colonne où se trouve la pièce
		/// @return Ligne
		int get_col() const { return col; }

		/// Renvoie la position "canonique" de la case
		/// @return Position canonique
		std::string to_string() const;

		/// Constructeur de la classe
		/// @param row Ligne de la case
		/// @param col Colonne de la case
		Square(int row, int col);

		/// Constructeur de copie de la classe
		explicit Square(const std::string &);
};

#endif