#include "pieces/reine.hpp"
#include "echiquier.hpp"

bool Reine::est_mouvement_legal(Square org, Square dest) const
{

	int row_org, col_org, row_dest, col_dest;
	dest.get_row_col(row_dest, col_dest);
	org.get_row_col(row_org, col_org);

	if (!Piece::est_mouvement_legal(org, dest))
		return false;
	if (row_org == row_dest)
	{
		// Déplacement horizontal
		int direction = (col_dest - col_org) > 0 ? 1 : -1;
		for (int col = col_org + direction; col != col_dest; col += direction)
		{
			Piece* piece = echiquier->get_piece(Square(row_dest, col));
			if (piece != nullptr)
				return false;
		}
		return true;
	}
	else if (col_org == col_dest)
	{
		// Déplacement vertical
		int direction = (row_dest - row_org) > 0 ? 1 : -1;
		for (int row = row_org + direction; row != row_dest; row += direction)
		{
			Piece* piece = echiquier->get_piece(Square(row, col_dest));
			if (piece != nullptr)
				return false;
		}
		return true;
	}
	else if (abs(row_org - row_dest) == abs(col_org - col_dest))
	{
		// Déplacement diagonal
		// Vérification si aucune pièce n'est présente entre la case d'origine et de destination
		int directionRow = (row_dest - row_org) > 0 ? 1 : -1;
		int directionCol = (col_dest - col_org) > 0 ? 1 : -1;
		for (int row = row_org + directionRow, col = col_org + directionCol;
			 row != row_dest && col != col_dest;
			 row += directionRow, col += directionCol)
		{
			Piece* piece = echiquier->get_piece(Square(row, col));
			if (piece != nullptr)
				return false;
		}
		return true;
	} else {
		return false;
	}
}

bool Reine::est_menace(Square org, Square dest) const {
	return est_mouvement_legal(org, dest);
}