#include "pieces/roi.hpp"
#include <iostream>

bool Roi::est_mouvement_legal(Square org, Square dest) const {
	int row_org, col_org, row_dest, col_dest;
	dest.get_row_col(row_dest, col_dest);
	org.get_row_col(row_org, col_org);

	// Cas de base
	if(!Piece::est_mouvement_legal(org, dest)) return false;
	else{
		// Déplacement de une case
		return (abs(row_org - row_dest) == 1 && abs(col_org - col_dest) == 1) 
			|| (abs(row_org - row_dest) == 0 && abs(col_org - col_dest) == 1)
			|| (abs(row_org - row_dest) == 1 && abs(col_org - col_dest) == 0);
	}
}

bool Roi::est_menace(Square org, Square dest) const {
	return est_mouvement_legal(org, dest);
}

std::string Roi::get_name() const {
	if(isChecked)
		return "\033[1;31m" + Piece::get_name() + "\033[0m";
	else
		return Piece::get_name();
}