#include "pieces/tour.hpp"
#include "echiquier.hpp"

bool Tour::est_mouvement_legal(Square org, Square dest) const {
	int row_org, col_org, row_dest, col_dest;
	dest.get_row_col(row_dest, col_dest);
	org.get_row_col(row_org, col_org);

	// Cas de base
	if(!Piece::est_mouvement_legal(org, dest)) return false;
	else{
		if (row_org == row_dest) {
			// Déplacement horizontal
			int direction = (col_dest - col_org) > 0 ? 1 : -1;
			for (int col = col_org + direction; col != col_dest; col += direction) {
				Piece* piece = echiquier->get_piece(Square(row_dest, col));
				if (piece != nullptr)
					return false;
			}
			return true;
		} else if (col_org == col_dest) {
			// Déplacement vertical
			int direction = (row_dest - row_org) > 0 ? 1 : -1;
			for (int row = row_org + direction; row != row_dest; row += direction) {
				Piece* piece = echiquier->get_piece(Square(row, col_dest));
				if (piece != nullptr)
					return false;
			}
			return true;
		} else {
			// La tour ne peut pas se déplacer en diagonale
			return false;
		}
	}
}

bool Tour::est_menace(Square org, Square dest) const {
	return est_mouvement_legal(org, dest);
}